;
; Berechnen einer Potenz
;

:0
	data _main, we000h, wf000h

;
; Stringtabelle und Speicher fuer die Fliesskommazahlen
;

:1000h
BasisText:
	data "Basis    : "
ExpText:
	data "Exponent : "
ErgText:
	data "Ergebnis : "
Enter:
	data "\n"

:align
Zahlen:
	data 0.0, 0.0

;
; Hauptprogramm
;
_main:
	load # BasisText
	sprint
	load # Zahlen
	fread
	load # ExpText
	sprint
	read
	push
	load # Zahlen + 8		; Pointer auf Ergebnis
	push
	swap
	load # Zahlen			; Pointer auf Basis
	exch
	call _pow
	push
	load # ErgText
	sprint
	pop
	fprint
	load # Enter
	sprint
	jump 0

;
; pow - Berechnung von ganzzahligen Potenzen
;
; Eingabe:  Stack[0]      Pointer auf Basis
;           Stack[1]      Adresse, an die das Ergebnis gespeichert werden
;                         soll
;           Akku          Exponent
;
; Ausgabe:  Akku          Pointer auf das Ergebnis wie oben angegeben
;
; a ^ b  =  (a^2)^(b/2) wenn b gerade
;        =  a * a^(b-1) wenn b ungerade
;

_pow:
	swap
	dup
	exch
	push
	load # 1
	itof
	pop
	swap
	call _powloop
	pop
	pop
	ret

_powloop:
	bzero _powret
	push
	and #$01
	bzero _powquad
	pop
	add # -1
	call _pqent
	swap
	dup
	pop
	swap
	dup
	fmult
_powret:
	ret

_powquad:
	pop
_pqent:
	bzero _powret
	shr # 1
	call _powloop
	swap
	dup
	dup
	pop
	fmult
	swap
	ret

